"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RpcError = void 0;
/**
   * RpcError is a simple error wrapper holding the request and the response.
   */
class RpcError extends Error {
    constructor(message, request, response, code) {
        super(message);
        this.name = 'RpcError';
        this.message = message || '';
        this.request = request;
        this.response = response;
        this.code = code;
    }
    toString() {
        return this.message;
    }
    getRequest() {
        return this.request;
    }
    getResponse() {
        return this.response;
    }
    getCode() {
        return this.code;
    }
    hasMessage() {
        return this.message !== undefined;
    }
    hasResponse() {
        return this.response !== undefined;
    }
}
exports.RpcError = RpcError;
